.686
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc

include     \masm32\macros\macros.asm

include     \masm32\include\masm32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\msvcrt.inc
; include     \masm32\include\advapi32.inc

includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\msvcrt.lib
; includelib  \masm32\lib\advapi32.lib


.data
                   ; the byte counts of test1.exe  2560 bytes long
                   ; counts of byte value 0 to 255 
                   ;  0 appeared 1781 times
count       dd     1781,10,12,7,16,5,2,2,5,2,3,1,4,4,2,1
            dd     11,1,0,2,3,4,0,0,2,0,1,1,3,0,0,1
            dd     52,2,0,8,4,12,1,0,2,0,0,0,4,7,6,1
            dd     20,0,2,1,4,5,0,0,4,1,0,2,1,5,1,1
            dd     33,1,2,4,2,7,4,1,1,2,2,1,2,1,2,1
            dd     6,0,1,4,1,2,0,2,0,0,1,0,0,1,0,3
            dd     9,8,2,5,14,21,4,2,9,7,5,3,12,5,16,9
            dd     4,0,11,6,22,15,1,0,2,2,0,0,0,0,0,3
            dd     6,1,1,8,2,1,0,0,0,3,0,10,1,6,0,4
            dd     2,0,0,1,2,0,0,0,0,0,0,1,0,0,0,0
            dd     3,2,0,0,0,0,0,0,2,0,0,1,1,0,0,0
            dd     0,1,0,0,2,2,0,0,2,1,4,11,0,1,0,0
            dd     7,2,4,3,4,0,1,2,6,2,1,1,17,7,3,4
            dd     4,1,0,0,0,0,1,4,0,0,2,1,0,0,0,0
            dd     2,1,0,0,2,0,0,0,11,1,0,3,1,0,2,1
            dd     0,1,1,0,3,1,1,5,2,0,1,1,2,0,12,31

frac        dd     0,0
reci        dd     0,0

log2        dd     0,0
ent         dd     0,0

fl2r        dd     0,0,0,0

entp        dd     0,0
rans        dd     0,0

total       dd     2560,0,0,0   ; total number of bytes

szMessage   db     256 dup (0)
szCaption   db     'The entropy of the file',0

                   ; log 2  of  1 0/16  to  1 15/16
logtab      db       0, 22, 43, 63, 82,100,117,134
            db     149,164,179,193,206,219,232,244

eak         dd     0
ebk         dd     0
eck         dd     0
edk         dd     0
esy         dd     0
edy         dd     0
esb         dd     0
ebb         dd     0

.code
start:
            ;============================================
            ; esi  index into byte count
            ;============================================
            mov     esi, 0

     again: 
            ;============================================
            ; frac : create a fixed point number 32.32
            ;        count[i] / total
            ;
            ; stored  lo dd, hi dd <-- fraction . integer
            ;         ent+0, ent+4 <-- fra(ent)   int(ent)
            ;
            ;         a conceptual view with numbers
            ; example 12.5  is 12 2147483648
            ;           .5  is    2147483648 / 4294967296
            ;         23.25 is 23 1073741824             
            ;============================================
            mov     edx, count[esi*4]  ;  MUST BE  count < total
            mov     eax, 0
            div     total
            mov     frac+0, eax
            mov     frac+4, 0

            ;============================================
            ; check if frac is 0.0   (prevents div by 0)
            ;          set entp[i] = 0.0
            ;          jmp ent = ent + entp[i]
            ;============================================
            xor     eax, eax
            mov     entp+0, eax
            mov     entp+4, eax
            or      eax, frac+0
            or      eax, frac+4
            jz sum                ; if frac 0.0 jmp  


            ;============================================
            ; reci : reciprocal frac
            ;          1 / frac
            ;          
            ;============================================
            mov     edx, 1
            mov     eax, 0
            div     frac+0        ; only use fra(frac)
            mov     reci+0, edx   ; remainder -> fra(reci)
            mov     reci+4, eax   ; quotient  -> int(reci)

            ; if fra(reci) <> 0
            ;   if cnt[i] * int(reci) == total
            ;     fra(reci) = 0
            ;   else
            ;     fra(reci) = (int(reci) * 2^32) / fra(frac)
            ;   endif
            ; endif

            ;============================================
            ; check is fra(reci) is correct
            ;         rounding + binary vs decimal 
            ;         limited resolution (32 bit fraction
            ;         1 / (16 / 2560) should be 160.0
            ;         
            ;         but 1/160 not exact as dword
            ;             26843545
            ;         so  1 / (1/160) becomes
            ;             160 integer and 15360 fractional
            ; verify + correction
            ;   if count[i] * int(reci) == total
            ;   then is an exact number  set fra(reci) = 0
            ;      16 * 160 == 2560
            ;============================================
            mov edx, reci+0
            .if edx != 0          
               mov eax, count[esi*4]
               mul reci+4
               cmp eax, total    ; should it have been exact ?
               jnz skip
               mov reci+0, 0     ; YES == total so make fra(reci) = 0
               jmp done
      skip:
               mov edx, reci+0   ; NO  <> total  use remainder ie fra(reci)
               mov eax, 0
               div frac+0        ; fra(reci) * 2^32 / fra(frac) 
               mov reci+0, eax   ; fra(reci) gets quotient
      done:
            .endif

            ;============================================
            ; log2 : log base2 of reci
            ;
            ;        if int(reci) is power of 2  AND
            ;           fra(reci) == 0
            ;        then fully accurate
            ;
            ;        if reci < 2 then
            ;          log2 = 0 1/2    MUST FIX !!
            ;
            ;        if int(reci) NOT power of 2
            ;          Use 16 entry lookup table  IMPROVE ! 
            ;          added to power of 2 of int(reci)
            ;
            ;          table entry picked by
            ;          
            ;          int(reci) - int(power of 2 reci)
            ;          
            ;  Ex 160  log2 (128)  = 7
            ;          log2 (160)  = 7.3219280948873623478...
            ;                        7 1382670639
            ;          log2 (160/128)
            ;          log2 (1.25) = 0.3219280948873623478
            ;
            ;          (160-128)/128 = 32/128 = 1/4
            ;          1/4 * 16 = 4  
            ;          lookup item 4  which is 82 add 1
            ;          83 / 256    = 0.32421875
            ;                      = 1392508928
            ;
            ;          so log2 (160) = 7 1392508928
            ;============================================
            bsr     eax, reci+4
            mov     log2+0, 0
            mov     log2+4, eax
            .if eax == 0                   ; 1 value lookup table
               mov     log2+0, 2147483648  ; FIX int(reci) < 2  ->  log2 (reci) = 0 1/2
            .endif   
            bsf     edx, reci+4
            xor     eax, edx
            jz calc           ; ignore reci+0 for now
                              ; exact only if power 2 AND reci+0 = 0
                              
            ; reci / reci as power of 2  call it  rans
            ; get log2 ( rans ) -> fra log2
            ;     log2 = log2 + fra log2

            xor     ecx, ecx
            xor     eax, eax
            mov     edx, reci+4
            bsr     eax, reci+4
            bts     ecx, eax
            xor     eax, eax
            sub     edx, ecx
            div     ecx
            bswap   eax
            and     eax, 255
            shr     eax, 4
            mov      al, byte ptr logtab[eax]
            inc     eax          ; add because original was truncated
            bswap   eax
            mov     log2+0, eax  ; fra(log2) get the approximation
            

      calc: 
            ; frac * log2 ( reci )
            ; entp := frac+0 * (log2+4 * 2^32 + log2+0)
            ;
            ;         log2+4  log2+0
            ;            *    frac+0
            ;         --------------
            ;          f0 l0  f0 l0
            ;   f0 l4  f0 l4
            ;   ====================
            ;   f0 l4  f0 l4+0
            ;
            mov     eax, frac+0
            mov     ecx, eax
            mul     log2+0
            mov     fl2r+0, eax
            mov     fl2r+4, edx
            mov     eax, ecx
            mul     log2+4
            add     fl2r+4, eax
            adc     fl2r+8, edx
            adc     fl2r+12, 0
            mov     eax, fl2r+4
            mov     edx, fl2r+8            
            mov     entp+0, eax
            mov     entp+4, edx

      sum:
            ; add entp to ent
            mov     eax, entp+0
            mov     edx, entp+4
            add     ent+0, eax
            adc     ent+4, edx

            inc     esi
            cmp     esi, 256     ; index 0 to 255  256 == exit
            jnz again

            mov    eax, ent+0
            mov    edx, ent+4
            invoke wsprintf,ADDR szMessage,SADD("Entropy  %u  %u / 4294967296",13,10,"really 1/8 of it."),edx,eax
            invoke MessageBox, 0, ADDR szMessage, ADDR szCaption, MB_OK

            ; ent / 8
            ; to be correct, entropy on an 8 bit item
            ; should be log base 256  NOT  log base 2
            ; so the range 0 to 8.0  should be scaled by 1/8
            ;       giving 0 to 1.0
            ;
            ; entropy on a 1 bit item uses log base 2
            ;       giving 0 to 1.0
            ;
            mov     eax, ent+4
            shrd    ent+0, eax, 3
            shr     ent+4, 3

            ret
end         start